Index: /branches/2521_ProblemRefactoring/HeuristicLab 3.3.sln
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab 3.3.sln	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab 3.3.sln	(revision 17461)
@@ -458,4 +458,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.PTSP.Views-3.3", "HeuristicLab.Problems.PTSP.Views\3.3\HeuristicLab.Problems.PTSP.Views-3.3.csproj", "{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Scheduling-3.3", "HeuristicLab.Problems.Scheduling\3.3\HeuristicLab.Problems.Scheduling-3.3.csproj", "{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Scheduling.Views-3.3", "HeuristicLab.Problems.Scheduling.Views\3.3\HeuristicLab.Problems.Scheduling.Views-3.3.csproj", "{78763A4E-E163-48C2-98EB-709760D06F25}"
 EndProject
 Global
@@ -2229,4 +2233,28 @@
 		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x86.ActiveCfg = Release|x86
 		{90B6CA12-9791-4430-B2D7-CD3ED7F75E2B}.Release|x86.Build.0 = Release|x86
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Debug|x64.ActiveCfg = Debug|x64
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Debug|x64.Build.0 = Debug|x64
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Debug|x86.ActiveCfg = Debug|x86
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Debug|x86.Build.0 = Debug|x86
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|Any CPU.Build.0 = Release|Any CPU
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|x64.ActiveCfg = Release|x64
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|x64.Build.0 = Release|x64
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|x86.ActiveCfg = Release|x86
+		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|x86.Build.0 = Release|x86
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x64.ActiveCfg = Debug|x64
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x64.Build.0 = Debug|x64
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x86.ActiveCfg = Debug|x86
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x86.Build.0 = Debug|x86
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|Any CPU.Build.0 = Release|Any CPU
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x64.ActiveCfg = Release|x64
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x64.Build.0 = Release|x64
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x86.ActiveCfg = Release|x86
+		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Collections/3.3/IObservableCollection.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Collections/3.3/IObservableCollection.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Collections/3.3/IObservableCollection.cs	(revision 17461)
@@ -26,4 +26,5 @@
 namespace HeuristicLab.Collections {
   [StorableType("289d81e9-a167-416c-aaa8-c40aa1ea96f9")]
-  public interface IObservableCollection<T> : ICollection<T>, INotifyObservableCollectionItemsChanged<T>, INotifyPropertyChanged { }
+  public interface IObservableCollection<T> : ICollection<T>, INotifyObservableCollectionItemsChanged<T>, INotifyPropertyChanged {
+  }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Collections/3.3/ObservableCollection.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Collections/3.3/ObservableCollection.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Collections/3.3/ObservableCollection.cs	(revision 17461)
@@ -20,5 +20,4 @@
 #endregion
 
-using HEAL.Attic;
 using System;
 using System.Collections;
@@ -26,4 +25,5 @@
 using System.ComponentModel;
 using System.Linq;
+using HEAL.Attic;
 
 namespace HeuristicLab.Collections {
@@ -97,11 +97,12 @@
     public void AddRange(IEnumerable<T> collection) {
       int capacity = list.Capacity;
-      ICollection<T> items = collection as ICollection<T> ?? collection.ToList();
+      var items = collection as ICollection<T> ?? collection.ToList();
       list.AddRange(items);
       if (items.Count > 0) {
+        OnItemsAdded(items);
         if (list.Capacity != capacity)
           OnPropertyChanged("Capacity");
-        OnPropertyChanged("Count");
-        OnItemsAdded(items);
+        OnPropertyChanged("Item[]");
+        OnPropertyChanged("Count");
       }
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Core/3.3/Interfaces/IConstrainedValueParameter.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Core/3.3/Interfaces/IConstrainedValueParameter.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Core/3.3/Interfaces/IConstrainedValueParameter.cs	(revision 17461)
@@ -1,2 +1,3 @@
+using System.Collections.Generic;
 using HEAL.Attic;
 #region License Information
@@ -26,4 +27,6 @@
   public interface IConstrainedValueParameter<T> : IValueParameter<T> where T : class, IItem {
     IItemSet<T> ValidValues { get; }
+
+    void Populate(IEnumerable<IItem> items);
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj	(revision 17461)
@@ -128,5 +128,5 @@
     <Compile Include="Interfaces\IScheduleCreator.cs" />
     <Compile Include="Interfaces\IScheduleCrossover.cs" />
-    <Compile Include="Interfaces\ISchedule.cs" />
+    <Compile Include="Interfaces\IScheduleSolution.cs" />
     <Compile Include="Interfaces\IScheduleDecoder.cs" />
     <Compile Include="Interfaces\IScheduleEncoding.cs" />
@@ -138,5 +138,5 @@
     <Compile Include="JobSequenceMatrix\Crossovers\JSMSXXCrossover.cs" />
     <Compile Include="JobSequenceMatrix\JobSequenceMatrixEncoding.cs" />
-    <Compile Include="JobSequenceMatrix\JSMEncoding.cs" />
+    <Compile Include="JobSequenceMatrix\JSM.cs" />
     <Compile Include="JobSequenceMatrix\JSMRandomCreator.cs" />
     <Compile Include="JobSequenceMatrix\Manipulators\JSMManipulator.cs" />
@@ -149,5 +149,5 @@
     <Compile Include="PermutationWithRepetition\Manipulators\PWRInsertionManipulator.cs" />
     <Compile Include="PermutationWithRepetition\PermutationWithRepetitionEncoding.cs" />
-    <Compile Include="PermutationWithRepetition\PWREncoding.cs" />
+    <Compile Include="PermutationWithRepetition\PWR.cs" />
     <Compile Include="PermutationWithRepetition\PWRRandomCreator.cs" />
     <Compile Include="Plugin.cs" />
@@ -158,5 +158,5 @@
     <Compile Include="PriorityRulesVector\Manipulators\PRVUniformOnePositionManipulator.cs" />
     <Compile Include="PriorityRulesVector\PriorityRulesVectorEncoding.cs" />
-    <Compile Include="PriorityRulesVector\PRVEncoding.cs" />
+    <Compile Include="PriorityRulesVector\PRV.cs" />
     <Compile Include="PriorityRulesVector\PRVRandomCreator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCreator.cs	(revision 17461)
@@ -28,5 +28,5 @@
   [StorableType("d6738639-c5fc-46af-8997-7527ea718759")]
   public interface IScheduleCreator<TSchedule> : ISolutionCreator<TSchedule>, IScheduleOperator
-  where TSchedule : class,ISchedule {
+  where TSchedule : class, IScheduleSolution {
     ILookupParameter<TSchedule> ScheduleParameter { get; }
     IValueLookupParameter<IntValue> JobsParameter { get; }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleCrossover.cs	(revision 17461)
@@ -27,6 +27,6 @@
   [StorableType("809a6136-3a7a-4389-9119-2bb48f6d650a")]
   public interface IScheduleCrossover : ICrossover, IScheduleOperator {
-    ILookupParameter<ISchedule> ChildParameter { get; }
-    IScopeTreeLookupParameter<ISchedule> ParentsParameter { get; }
+    ILookupParameter<IScheduleSolution> ChildParameter { get; }
+    IScopeTreeLookupParameter<IScheduleSolution> ParentsParameter { get; }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleDecoder.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleDecoder.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleDecoder.cs	(revision 17461)
@@ -26,13 +26,13 @@
   [StorableType("010C752F-0F5E-4B93-8695-8DD74903DBE7")]
   public interface IScheduleDecoder : IScheduleOperator {
-    ILookupParameter<ISchedule> ScheduleEncodingParameter { get; }
+    ILookupParameter<IScheduleSolution> ScheduleEncodingParameter { get; }
     ILookupParameter<Schedule> ScheduleParameter { get; }
     ILookupParameter<ItemList<Job>> JobDataParameter { get; }
 
-    Schedule DecodeSchedule(ISchedule solution, ItemList<Job> jobData);
+    Schedule DecodeSchedule(IScheduleSolution solution, ItemList<Job> jobData);
   }
 
   public interface IScheduleDecoder<TSchedule> : IScheduleDecoder
-    where TSchedule : class, ISchedule {
+    where TSchedule : class, IScheduleSolution {
     Schedule DecodeSchedule(TSchedule solution, ItemList<Job> jobData);
   }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleEncoding.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleEncoding.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleEncoding.cs	(revision 17461)
@@ -22,13 +22,13 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Optimization;
-using HEAL.Attic;
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   [StorableType("09b9d24c-2576-495a-b06c-338d095cba0d")]
-  public interface IScheduleEncoding : IEncoding<ISchedule> {
-    IFixedValueParameter<ItemList<Job>> JobDataParameter { get; set; }
+  public interface IScheduleEncoding : IEncoding<IScheduleSolution> {
+    IValueParameter<ItemList<Job>> JobDataParameter { get; set; }
     IFixedValueParameter<IntValue> JobsParameter { get; set; }
     IFixedValueParameter<IntValue> ResourcesParameter { get; set; }
@@ -39,9 +39,9 @@
 
 
-    Schedule Decode(ISchedule schedule, ItemList<Job> jobData);
+    Schedule Decode(IScheduleSolution schedule, ItemList<Job> jobData);
   }
 
   public interface IScheduleEncoding<TSchedule> : IEncoding<TSchedule>
-    where TSchedule : class, ISchedule {
+    where TSchedule : class, IScheduleSolution {
 
   }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleManipulator.cs	(revision 17461)
@@ -27,5 +27,5 @@
   [StorableType("aa89fd6f-db49-457d-abc9-5600aa8f24e5")]
   public interface IScheduleManipulator : IManipulator, IScheduleOperator {
-    ILookupParameter<ISchedule> ScheduleParameter { get; }
+    ILookupParameter<IScheduleSolution> ScheduleParameter { get; }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleSolution.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleSolution.cs	(revision 17461)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/Interfaces/IScheduleSolution.cs	(revision 17461)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  public interface IScheduleSolution : IEncodedSolution { }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMCrossover.cs	(revision 17461)
@@ -35,5 +35,5 @@
     public JSMCrossover() : base() { }
 
-    public abstract JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2);
+    public abstract JSM Cross(IRandom random, JSM parent1, JSM parent2);
 
     public override IOperation InstrumentedApply() {
@@ -41,5 +41,5 @@
 
       ChildParameter.ActualValue =
-        Cross(RandomParameter.ActualValue, parents[0] as JSMEncoding, parents[1] as JSMEncoding);
+        Cross(RandomParameter.ActualValue, parents[0] as JSM, parents[1] as JSM);
 
       return base.InstrumentedApply();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMJOXCrossover.cs	(revision 17461)
@@ -40,6 +40,6 @@
     }
 
-    public static JSMEncoding Apply(IRandom random, JSMEncoding p1, JSMEncoding p2) {
-      var result = new JSMEncoding(random.Next());
+    public static JSM Apply(IRandom random, JSM p1, JSM p2) {
+      var result = new JSM(random.Next());
 
       int nrOfResources = p1.JobSequenceMatrix.Count;
@@ -53,6 +53,6 @@
 
       bool dominantParent = random.Next(2) == 1;
-      JSMEncoding parent1 = dominantParent ? p1 : p2;
-      JSMEncoding parent2 = dominantParent ? p2 : p1;
+      JSM parent1 = dominantParent ? p1 : p2;
+      JSM parent2 = dominantParent ? p2 : p1;
 
       //Fill childmatrix with values
@@ -75,5 +75,5 @@
     }
 
-    public override JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public override JSM Cross(IRandom random, JSM parent1, JSM parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMOXCrossover.cs	(revision 17461)
@@ -38,6 +38,6 @@
     }
 
-    public static JSMEncoding Apply(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
-      var result = new JSMEncoding(random.Next());
+    public static JSM Apply(IRandom random, JSM parent1, JSM parent2) {
+      var result = new JSM(random.Next());
 
       for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
@@ -50,5 +50,5 @@
     }
 
-    public override JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public override JSM Cross(IRandom random, JSM parent1, JSM parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Crossovers/JSMSXXCrossover.cs	(revision 17461)
@@ -39,6 +39,6 @@
     }
 
-    public static JSMEncoding Apply(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
-      var result = new JSMEncoding(random.Next());
+    public static JSM Apply(IRandom random, JSM parent1, JSM parent2) {
+      var result = new JSM(random.Next());
       int subSequenceLength = random.Next(parent1.JobSequenceMatrix[0].Length);
       for (int i = 0; i < parent1.JobSequenceMatrix.Count; i++) {
@@ -91,5 +91,5 @@
     }
 
-    public override JSMEncoding Cross(IRandom random, JSMEncoding parent1, JSMEncoding parent2) {
+    public override JSM Cross(IRandom random, JSM parent1, JSM parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Decoder/JSMDecoder.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Decoder/JSMDecoder.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Decoder/JSMDecoder.cs	(revision 17461)
@@ -34,5 +34,5 @@
   [Item("JobSequenceMatrixDecoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequence Matrix.")]
   [StorableType("BBE354C2-7599-43CC-ACDC-F8F0F65BE3F5")]
-  public class JSMDecoder : ScheduleDecoder<JSMEncoding> {
+  public class JSMDecoder : ScheduleDecoder<JSM>, IJSMOperator {
 
     public IFixedValueParameter<EnumValue<JSMDecodingErrorPolicy>> DecodingErrorPolicyParameter {
@@ -64,5 +64,5 @@
     }
 
-    private static Task SelectTaskFromConflictSet(JSMEncoding solution, JSMDecodingErrorPolicy decodingErrorPolicy, JSMForcingStrategy forcingStrategy, int conflictedResourceNr, int progressOnConflictedResource, ItemList<Task> conflictSet, IRandom random) {
+    private static Task SelectTaskFromConflictSet(JSM solution, JSMDecodingErrorPolicy decodingErrorPolicy, JSMForcingStrategy forcingStrategy, int conflictedResourceNr, int progressOnConflictedResource, ItemList<Task> conflictSet, IRandom random) {
       if (conflictSet.Count == 1)
         return conflictSet[0];
@@ -108,5 +108,5 @@
     }
 
-    private static void ApplyForcingStrategy(JSMForcingStrategy forcingStrategy, JSMEncoding solution, int conflictedResource, int newResolutionIndex, int progressOnResource, int newResolution) {
+    private static void ApplyForcingStrategy(JSMForcingStrategy forcingStrategy, JSM solution, int conflictedResource, int newResolutionIndex, int progressOnResource, int newResolution) {
       var jsm = solution.JobSequenceMatrix;
       if (forcingStrategy == JSMForcingStrategy.SwapForcing) {
@@ -130,9 +130,9 @@
     }
 
-    public override Schedule DecodeSchedule(JSMEncoding encoding, ItemList<Job> jobData) {
+    public override Schedule DecodeSchedule(JSM encoding, ItemList<Job> jobData) {
       return Decode(encoding, jobData, DecodingErrorPolicy, ForcingStrategy);
     }
 
-    public static Schedule Decode(JSMEncoding solution, ItemList<Job> jobData, JSMDecodingErrorPolicy decodingErrorPolicy, JSMForcingStrategy forcingStrategy) {
+    public static Schedule Decode(JSM solution, ItemList<Job> jobData, JSMDecodingErrorPolicy decodingErrorPolicy, JSMForcingStrategy forcingStrategy) {
       var random = new FastRandom(solution.RandomSeed);
       var jobs = (ItemList<Job>)jobData.Clone();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSM.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSM.cs	(revision 17461)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSM.cs	(revision 17461)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Text;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Job Sequence Matrix", "Represents the job sequence matrix solution.")]
+  [StorableType("8F19A51A-45F1-4C1D-BCD4-A9F57E40DDC5")]
+  public class JSM : Item, IScheduleSolution {
+
+    [Storable]
+    public ItemList<Permutation> JobSequenceMatrix { get; private set; }
+    [Storable]
+    public int RandomSeed { get; private set; }
+
+    [StorableConstructor]
+    protected JSM(StorableConstructorFlag _) : base(_) { }
+    protected JSM(JSM original, Cloner cloner)
+      : base(original, cloner) {
+      this.JobSequenceMatrix = cloner.Clone(original.JobSequenceMatrix);
+      this.RandomSeed = original.RandomSeed;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSM(this, cloner);
+    }
+    public JSM(int randomSeed)
+      : base() {
+      RandomSeed = randomSeed;
+      JobSequenceMatrix = new ItemList<Permutation>();
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+
+      foreach (Permutation p in JobSequenceMatrix) {
+        sb.AppendLine(p.ToString());
+      }
+
+      sb.Append("]");
+      return sb.ToString();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JSMRandomCreator.cs	(revision 17461)
@@ -30,5 +30,5 @@
   [Item("JobSequenceMatrixCreator", "Creator class used to create Job Sequence Matrix solutions for standard JobShop scheduling problems.")]
   [StorableType("F8053C69-31C2-4E05-8FA0-5AED15FAF804")]
-  public class JSMRandomCreator : ScheduleCreator<JSMEncoding>, IStochasticOperator {
+  public class JSMRandomCreator : ScheduleCreator<JSM>, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
@@ -48,6 +48,6 @@
     }
 
-    public static JSMEncoding Apply(int jobs, int resources, IRandom random) {
-      var solution = new JSMEncoding(random.Next());
+    public static JSM Apply(int jobs, int resources, IRandom random) {
+      var solution = new JSM(random.Next());
       for (int i = 0; i < resources; i++) {
         solution.JobSequenceMatrix.Add(new Permutation(PermutationTypes.Absolute, jobs, random));
@@ -56,5 +56,5 @@
     }
 
-    protected override JSMEncoding CreateSolution() {
+    protected override JSM CreateSolution() {
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JobSequenceMatrixEncoding.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JobSequenceMatrixEncoding.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/JobSequenceMatrixEncoding.cs	(revision 17461)
@@ -31,6 +31,7 @@
 
 namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Job Sequence Matrix Encoding", "Represents an encoding of schedules in form of a job sequence per resource.")]
   [StorableType("9C090369-0214-42E6-8C3E-369751F5A9E1")]
-  public sealed class JobSequenceMatrixEncoding : ScheduleEncoding<JSMEncoding> {
+  public sealed class JobSequenceMatrixEncoding : ScheduleEncoding<JSM> {
     [StorableConstructor]
     private JobSequenceMatrixEncoding(StorableConstructorFlag _) : base(_) { }
@@ -41,5 +42,5 @@
 
     public JobSequenceMatrixEncoding()
-      : base() {
+      : base("JSM") {
       SolutionCreator = new JSMRandomCreator();
       Decoder = new JSMDecoder();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMManipulator.cs	(revision 17461)
@@ -34,8 +34,8 @@
     public JSMManipulator() : base() { }
 
-    protected abstract void Manipulate(IRandom random, ISchedule individual);
+    protected abstract void Manipulate(IRandom random, IScheduleSolution individual);
 
     public override IOperation InstrumentedApply() {
-      var solution = ScheduleParameter.ActualValue as JSMEncoding;
+      var solution = ScheduleParameter.ActualValue as JSM;
       if (solution == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type JSMEncoding.");
       Manipulate(RandomParameter.ActualValue, solution);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMShiftChangeManipulator.cs	(revision 17461)
@@ -42,5 +42,5 @@
     }
 
-    public static void Apply(IRandom random, JSMEncoding individual) {
+    public static void Apply(IRandom random, JSM individual) {
       int nrOfJobs = individual.JobSequenceMatrix[0].Length;
       int jobIndex = random.Next(nrOfJobs);
@@ -63,6 +63,6 @@
     }
 
-    protected override void Manipulate(IRandom random, ISchedule encoding) {
-      var solution = encoding as JSMEncoding;
+    protected override void Manipulate(IRandom random, IScheduleSolution encoding) {
+      var solution = encoding as JSM;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type JSMEncoding");
       Apply(random, solution);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/JobSequenceMatrix/Manipulators/JSMSwapManipulator.cs	(revision 17461)
@@ -40,5 +40,5 @@
     }
 
-    public static void Apply(IRandom random, JSMEncoding individual) {
+    public static void Apply(IRandom random, JSM individual) {
       int resourceIndex = random.Next(individual.JobSequenceMatrix.Count);
       Permutation p = individual.JobSequenceMatrix[resourceIndex];
@@ -50,6 +50,6 @@
     }
 
-    protected override void Manipulate(IRandom random, ISchedule individual) {
-      var solution = individual as JSMEncoding;
+    protected override void Manipulate(IRandom random, IScheduleSolution individual) {
+      var solution = individual as JSM;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type JSMEncoding");
       Apply(random, solution);
